#include <pards/SyncQueue.h>
#include <pards/Merger.h>

class Item{
public:
  int val;
  int id;
};

int main()
{
  void generator(int,Merger<Item>*);
  void consumer(SyncQueue<Item>*);

  pards_init();

  SyncQueue<Item> *first = new SyncQueue<Item>(2); 
  Merger<Item> *merger = new Merger<Item>(first,2);
  
  SPAWN(generator(1,merger));
  SPAWN(generator(2,merger));
  SPAWN(consumer(first));

  pards_finalize();
}


void generator(int id, Merger<Item> *m)
{
  /*  if(id == 1) {
    m->increase_referer();
    SPAWN(generator(3,m));
    }*/
  srand(id);
  for(int i = 0; i < 3; i++){
    sleep(rand()%3);
    Item it;
    it.val = i;
    it.id = id;
    m->put(it);
  }
  m->release();
}

void consumer(SyncQueue<Item> *l)
{
  SyncQueue<Item> *current = l;
  while(1){
    Item it = current->read();
    printf("val = %d, id = %d\n",it.val, it.id);
    current = current->release();
    if(current == 0) break;
  }
}
